package de.effigenix.application.masterdata.supplier;

import de.effigenix.domain.masterdata.supplier.Supplier;
import de.effigenix.domain.masterdata.supplier.SupplierError;
import de.effigenix.domain.masterdata.supplier.SupplierId;
import de.effigenix.domain.masterdata.supplier.SupplierRepository;
import de.effigenix.shared.common.Result;
import de.effigenix.shared.persistence.UnitOfWork;
import de.effigenix.shared.security.ActorId;

import static de.effigenix.shared.common.Result.*;

public class ActivateSupplier {

    private final SupplierRepository supplierRepository;
    private final UnitOfWork unitOfWork;

    public ActivateSupplier(SupplierRepository supplierRepository, UnitOfWork unitOfWork) {
        this.supplierRepository = supplierRepository;
        this.unitOfWork = unitOfWork;
    }

    public Result<SupplierError, Supplier> execute(SupplierId supplierId, ActorId performedBy) {
        Supplier supplier;
        switch (supplierRepository.findById(supplierId)) {
            case Failure(var err) ->
                { return Result.failure(new SupplierError.RepositoryFailure(err.message())); }
            case Success(var opt) -> {
                if (opt.isEmpty()) {
                    return Result.failure(new SupplierError.SupplierNotFound(supplierId));
                }
                supplier = opt.get();
            }
        }
        supplier.activate();

        return unitOfWork.executeAtomically(() -> {
            switch (supplierRepository.save(supplier)) {
                case Failure(var err) ->
                    { return Result.failure(new SupplierError.RepositoryFailure(err.message())); }
                case Success(var ignored) -> { }
            }
            return Result.success(supplier);
        });
    }
}
